Index: /trunk/src/sh_err_console.c
===================================================================
--- /trunk/src/sh_err_console.c	(revision 584)
+++ /trunk/src/sh_err_console.c	(revision 1)
@@ -25,5 +25,4 @@
 #include "sh_error.h"
 #include "sh_utils.h"
-#include "sh_sem.h"
 
 #undef  FIL__
@@ -33,11 +32,9 @@
 #include <sys/types.h>
 #include <fcntl.h>
-#include <sys/stat.h>
 #include <unistd.h>
 #include <signal.h>
-#include <sys/socket.h>
-#include <sys/un.h>
 
 extern int  OnlyStderr;
+
  
 #if !defined(O_NONBLOCK)
@@ -56,8 +53,4 @@
 #include <sys/msg.h>
 
-#if !defined(EIDRM)
-#define EIDRM (EINVAL)
-#endif
-
 struct sh_msgbuf {
   long mtype;
@@ -73,22 +66,20 @@
 /* Open the SysV message queue, creating it when neccesary
  */
-static int open_queue(void)
+static int open_ipc(void)
 {
   key_t            key;
-#if defined(WITH_TPT) 
-  char errbuf[SH_ERRBUF_SIZE];
-#endif
-
-  SL_ENTER(_("open_queue"));
+  int              error;
+
+  SL_ENTER(_("open_ipc"));
 
   /* get key
    */
-  key = ftok (DEFAULT_DATAROOT, '#');
-
+  key = ftok ("/tmp", '#');
   if (key == (key_t) -1)
     {
+      error = errno;
       TPT(( 0, FIL__, __LINE__, _("msg=<ftok: %s> errno=<%d>\n"), 
-	    sh_error_message(errno, errbuf, sizeof(errbuf)), errno));
-      SL_RETURN(-1, _("open_queue"));
+	    sh_error_message(error), error));
+      SL_RETURN(-1, _("open_ipc"));
     }
 
@@ -99,25 +90,27 @@
   if (msgid < 0)
     {
+      error = errno;
       TPT(( 0, FIL__, __LINE__, _("msg=<msgget: %s> errno=<%d>\n"), 
-	    sh_error_message(errno, errbuf, sizeof(errbuf)), errno));
-      SL_RETURN(-1, _("open_queue"));
-    }
-
-  SL_RETURN(0, _("open_queue"));
-}
-
-/* Close the SysV message queue and/or semaphore
+	    sh_error_message(error), error));
+      SL_RETURN(-1, _("open_ipc"));
+    }
+
+  SL_RETURN(0, _("open_ipc"));
+}
+
+/* Close the SysV message queue
  */
 void close_ipc (void)
 {
+  SL_ENTER(_("close_ipc"));
+
   if (msgid != (-1))
     (void) msgctl (msgid, IPC_RMID, NULL);
-  sh_sem_close();
-  return;
+  SL_RET0(_("close_ipc"));
 }
 
 /* Enable the message queue
  */
-int enable_msgq(const char * foo)
+int enable_msgq(char * foo)
 {
   int i;
@@ -128,33 +121,14 @@
 }
 
+/* #define MY_MAX_MSG    254 */
 #define MY_MAX_MSG    1022
 
-static void remove_message()
-{
-  int rc;
-  struct {
-    long    mtype;       /* Message type. */
-    char    mtext[128];  /* Message text. */
-  } recv_msg;
-
-  recv_msg.mtype = 1;
-  do {
-    rc = msgrcv(msgid, &recv_msg, sizeof(recv_msg.mtext), 1, 
-		MSG_NOERROR|IPC_NOWAIT);
-  } while (rc < 0 && errno == EINTR);
-
-  memset(&recv_msg, 0, sizeof(recv_msg));
-  return;
-}
-
-static int push_message_queue (const char * msg)
+static int push_message_queue (char * msg)
 {
   struct sh_msgbuf*   recv_msg = NULL;
   int              rc       = -1;
   static int       status   = -1;
+  int              error;
   int              count    = 0;
-#if defined(WITH_TPT) 
-  char errbuf[SH_ERRBUF_SIZE];
-#endif
 
   SL_ENTER(_("push_message_queue"));
@@ -169,10 +143,10 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<msg_queue not open>\n"))); 
-      status = open_queue();
+      status = open_ipc();
     }
 
   if (status < 0)
     {
-      TPT(( 0, FIL__, __LINE__, _("msg=<open_queue() failed>\n"))); 
+      TPT(( 0, FIL__, __LINE__, _("msg=<open_ipc() failed>\n"))); 
       SL_RETURN(-1, _("push_message_queue"));
     }
@@ -181,6 +155,6 @@
    *   long mtype;
    *   char mtext[1];  <-- sizeof(mtext) will be  1+MY_MAX_MSG
-   * } */
-
+   * }
+   */
   recv_msg = (struct sh_msgbuf*) SH_ALLOC(sizeof(struct sh_msgbuf)+MY_MAX_MSG);
   recv_msg->mtype = 1;
@@ -193,37 +167,45 @@
   if (count > 1)
     {
-      memset(recv_msg, 0, MY_MAX_MSG+1);
       SH_FREE(recv_msg);
       SL_RETURN(-1, _("push_message_queue"));
     }
 
-  do { errno = 0;
+  /* send the message
+   */ 
+  do {
+    errno = 0;
     rc = msgsnd(msgid, recv_msg, strlen(recv_msg->mtext)+1, IPC_NOWAIT);
-
-    if (rc == -1 && errno == EAGAIN)
-      remove_message();
-  } while (rc < 0 && (errno == EINTR && errno == EAGAIN));
+  }
+  while (rc < 0 && errno == EINTR);
   
   if (rc == -1 && errno != EAGAIN) 
     {
-      /* EIDRM is not in OpenBSD */
-      if (errno == EINVAL || errno == EIDRM) {
-	TPT(( 0, FIL__, __LINE__, _("msg=<msg_queue not open>\n"))); 
-	status = open_queue();
-	if (status == 0) {
-	  ++count;
-	  goto send_it; }
-      } else {
-	TPT(( 0, FIL__, __LINE__, _("msg=<msgsnd: %s> errno=<%d>\n"), 
-	      sh_error_message(errno, errbuf, sizeof(errbuf)), errno));
-	memset(recv_msg, 0, MY_MAX_MSG+1);
-	SH_FREE(recv_msg);
-	SL_RETURN(-1, _("push_message_queue"));
-      }
-    }
-
-  memset(recv_msg, 0, MY_MAX_MSG+1);
+      /* EIDRM is not in OpenBSD
+       */
+      if (errno == EINVAL
+#if defined(EIDRM)
+	  || errno == EIDRM
+#endif
+	  )
+	{
+	  TPT(( 0, FIL__, __LINE__, _("msg=<msg_queue not open>\n"))); 
+	  status = open_ipc();
+	  if (status == 0)
+	    {
+	      ++count;
+	      goto send_it;
+	    }
+	}
+      else
+	{
+	  error = errno;
+	  TPT(( 0, FIL__, __LINE__, _("msg=<msgsnd: %s> errno=<%d>\n"), 
+		sh_error_message(error), error));
+	  SH_FREE(recv_msg);
+	  SL_RETURN(-1, _("push_message_queue"));
+	}
+    }
+
   SH_FREE(recv_msg);
-
   SL_RETURN(0, _("push_message_queue"));
 }
@@ -240,25 +222,11 @@
 #endif
 
-#else /* no message queue */
-
-void close_ipc() { sh_sem_close(); return; }
-
 #endif
 
 static int count_dev_console = 0;
 
-typedef enum { SH_LOG_UNIX, SH_LOG_OTHER, SH_LOG_INDEF } sh_log_devtype;
-
-static sh_log_devtype dt[2] = { SH_LOG_INDEF, SH_LOG_INDEF };
-static int            st[2] = { SOCK_DGRAM, SOCK_DGRAM };
-
 void reset_count_dev_console(void)
 {
   count_dev_console = 0;
-  dt[0] = SH_LOG_INDEF;
-  dt[1] = SH_LOG_INDEF;
-  st[0] = SOCK_DGRAM;
-  st[1] = SOCK_DGRAM;
-  
   return;
 }
@@ -266,5 +234,5 @@
 /* ---- Set the console device. ----
  */
-int sh_log_set_console (const char * address)
+int sh_log_set_console (char * address)
 {
   SL_ENTER(_("sh_log_set_console"));
@@ -284,7 +252,7 @@
 
 #if defined(WITH_TRACE) || defined(WITH_TPT)
-char *  sh_log_console_name (void)
-{
-  if (sh.srvcons.name[0] == '\0' ||
+char *  sh_log_console_name ()
+{
+  if (! sh.srvcons.name || sh.srvcons.name[0] == '\0' ||
       0 == strcmp(sh.srvcons.name, _("NULL")))
     return (_("/dev/console"));
@@ -297,92 +265,11 @@
 #endif
 
-static int  find_socktype(const char * name)
-{
-#ifdef SOCK_SEQPACKET
-    int socktypes[3] = { SOCK_DGRAM, SOCK_SEQPACKET, SOCK_STREAM };
-    int try = 3;
-#else
-    int socktypes[2] = { SOCK_DGRAM, SOCK_STREAM };
-    int try = 2;
-#endif
-    int i;
-    for (i = 0; i < try; ++i) {
-	struct sockaddr_un addr;
-	int fd;
-    
-	if ( (fd = socket(AF_UNIX, socktypes[i], 0)) == -1) {
-	    return -1;
-	}
-	memset(&addr, 0, sizeof(addr));
-	addr.sun_family = AF_UNIX;
-	sl_strlcpy(addr.sun_path, name, sizeof(addr.sun_path));
-	if (connect(fd, (struct sockaddr*)&addr, sizeof(addr)) == 0) {
-	    close(fd);
-	    return socktypes[i];
-	}
-	close(fd);
-    }
-    return -1;
-}
-
-int sh_log_console_open (const char * name, int slot)
-{
-  int fd = -1;
-
-  if (dt[slot] == SH_LOG_INDEF)
-    {
-      struct stat sb;
-      if (retry_stat(FIL__, __LINE__, name, &sb) == 0)
-	{
-	  if ((sb.st_mode & S_IFMT) == S_IFSOCK)
-	    {
-	      dt[slot] = SH_LOG_UNIX;
-	      st[slot] = find_socktype(name);
-	      if (st[slot] == -1) {
-	        sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_E_SUBGEN,
-		   _("Could not determine socket type."),  
-		   name);
-	      }
-	    }
-	  else
-	    dt[slot] = SH_LOG_OTHER;
-	}
-    }
-      
-  if (dt[slot] == SH_LOG_OTHER) {
-    fd = open ( name, O_WRONLY|O_APPEND|O_NOCTTY|O_NONBLOCK);
-  }
-  else if (dt[slot] == SH_LOG_UNIX && st[slot] != -1) {
-    struct sockaddr_un addr;
-    
-    if ( (fd = socket(AF_UNIX, st[slot], 0)) == -1) {
-	  char ebuf[SH_ERRBUF_SIZE];
-	  int  errnum = errno;
-	  sh_error_handle ((-1), FIL__, __LINE__, errnum, MSG_E_SUBGEN,
-	    sh_error_message(errnum, ebuf, sizeof(ebuf)),  
-	    name);
-      return -1;
-    }
-    memset(&addr, 0, sizeof(addr));
-    addr.sun_family = AF_UNIX;
-    sl_strlcpy(addr.sun_path, name, sizeof(addr.sun_path));
-    if (connect(fd, (struct sockaddr*)&addr, sizeof(addr)) == -1) {
-	  char ebuf[SH_ERRBUF_SIZE];
-	  int  errnum = errno;
-	  sh_error_handle ((-1), FIL__, __LINE__, errnum, MSG_E_SUBGEN,
-	    sh_error_message(errnum, ebuf, sizeof(ebuf)),
-	    name);
-      return -1;
-    }
-  }
-  return fd;
-}
-
 /* ---- Print out a message. ----
  */
-int  sh_log_console (const /*@null@*/char *errmsg)
+int  sh_log_console (/*@null@*/char *errmsg)
 {
   static int service_failure[2] = { 0, 0};
   int    fd[2] = { -1, -1};
+  int    sflags;
   int    cc;
   size_t len;
@@ -391,6 +278,6 @@
   /* static int logkey_seen = 0; */
   int    error;
+  struct sigaction sa_new, sa_old;
   static int blockMe = 0;
-  int    val_return;
 
   SL_ENTER(_("sh_log_console"));
@@ -411,16 +298,21 @@
 #endif
 
+  sa_new.sa_handler = SIG_IGN;
+  (void) sigemptyset(&sa_new.sa_mask);
+  sa_new.sa_flags   = 0;
+
+  /* Ignore SIGPIPE in case the console is actually a pipe.
+   */
+  (void) retry_sigaction(FIL__, __LINE__, SIGPIPE, &sa_new, &sa_old);
+ 
   if (sh.flag.isdaemon == S_FALSE || OnlyStderr == S_TRUE)
     {
       len = strlen(errmsg);
-      do {
-	val_return = write(STDERR_FILENO, errmsg, len);
-      } while (val_return < 0 && errno == EINTR); 
-      do {
-	val_return = write(STDERR_FILENO, "\n", 1);
-      } while (val_return < 0 && errno == EINTR); 
+      (void) write(STDERR_FILENO, errmsg, len);
+      (void) write(STDERR_FILENO, "\n", 1);
       /* 
        * fprintf (stderr, "%s\n", errmsg); 
        */
+      (void) retry_sigaction(FIL__, __LINE__, SIGPIPE, &sa_old, NULL);
       blockMe = 0;
       SL_RETURN(0, _("sh_log_console"));
@@ -429,12 +321,28 @@
   /* --- daemon && initialized ---
    */
-  if ( OnlyStderr == S_FALSE ) 
-    {
-      fd[0] = sh_log_console_open ( sh.srvcons.name, 0);
-
-      if (sh.srvcons.alt[0] != '\0')
+  if ( (OnlyStderr == S_FALSE) ) 
+    {
+      fd[0] = open ( sh.srvcons.name, O_WRONLY|O_APPEND|O_NOCTTY|O_NONBLOCK);
+      if (fd[0] >= 0) {
+	sflags = (int) retry_fcntl(FIL__, __LINE__, fd[0], F_GETFL, 0);
+	if (sflags >= 0)
+	  {
+	    (void) retry_fcntl(FIL__, __LINE__, fd[0], 
+			       F_SETFL, sflags & ~O_NONBLOCK);
+	  }
+      }
+
+      if (sh.srvcons.alt != NULL && sh.srvcons.alt[0] != '\0')
 	{
-	  fd[1] = sh_log_console_open (sh.srvcons.alt, 1);
-	  ccMax = 2;
+	  fd[1] = open (sh.srvcons.alt, O_WRONLY|O_APPEND|O_NOCTTY|O_NONBLOCK);
+	  if (fd[1] >= 0) {
+	    sflags = (int) retry_fcntl(FIL__, __LINE__, fd[1], F_GETFL, 0);
+	    if (sflags >= 0)
+	      {
+		(void) retry_fcntl(FIL__, __LINE__, fd[1], 
+				   F_SETFL, sflags & ~O_NONBLOCK);
+	      }
+	    ccMax = 2;
+	  }
 	}
 
@@ -453,13 +361,7 @@
 	  if (fd[cc] >= 0)
 	    {
-	      do {
-		val_return = write(fd[cc], errmsg, strlen(errmsg));
-	      } while (val_return < 0 && errno == EINTR);
-	      if (dt[cc] != SH_LOG_UNIX || st[cc] == SOCK_STREAM) {
-	        do {
-	          val_return = write(fd[cc], "\r\n",              2);
-	        } while (val_return < 0 && errno == EINTR);
-	      }
-	      (void) sl_close_fd(FIL__, __LINE__, fd[cc]);
+	      (void) write(fd[cc], errmsg, strlen(errmsg));
+	      (void) write(fd[cc], "\r\n",              2);
+	      (void) close(fd[cc]);
 	      service_failure[cc] = 0;
 	    }
@@ -469,4 +371,5 @@
     retval = 0;
 
+  (void) retry_sigaction(FIL__, __LINE__, SIGPIPE, &sa_old, NULL);
   blockMe = 0;
   SL_RETURN(retval, _("sh_log_console"));
Index: /trunk/src/sh_err_log.c
===================================================================
--- /trunk/src/sh_err_log.c	(revision 584)
+++ /trunk/src/sh_err_log.c	(revision 1)
@@ -24,5 +24,4 @@
 #include <sys/types.h>
 #include <unistd.h>
-#include <time.h>
 
 #include "samhain.h"
@@ -70,5 +69,5 @@
   /* open the file, then check it 
    */
-  if ( SL_ISERROR(fd = sl_open_read (FIL__, __LINE__, path, SL_NOPRIV)))
+  if ( SL_ISERROR(fd = sl_open_read (path, SL_NOPRIV)))
     {
       fprintf(stderr, _("Could not open file <%s>\n"), path);
@@ -117,5 +116,5 @@
 static int just_list = S_FALSE;
 
-int sh_error_logverify_mod (const char * s)
+int sh_error_logverify_mod (char * s)
 {
   just_list = S_TRUE;
@@ -126,5 +125,5 @@
 } 
 
-int sh_error_logverify (const char * s)
+int sh_error_logverify (char * s)
 {
   SL_TICKET fd;
@@ -146,5 +145,4 @@
   char c_cont;
   int  chk_mode = CHK_KEY;
-  char hashbuf[KEYBUF_SIZE];
 
   sh_error_logoff();
@@ -164,5 +162,5 @@
     }
 
-  if ( SL_ISERROR(fd = sl_open_read (FIL__, __LINE__, s, SL_NOPRIV)) )
+  if ( SL_ISERROR(fd = sl_open_read (s, SL_NOPRIV)) )
     {
       fprintf(stderr, 
@@ -185,6 +183,6 @@
 #endif
 
-  buf  = (char *) SH_ALLOC( 2*SH_MSG_BUF+1 );
-  bufc = (char *) SH_ALLOC( 2*SH_MSG_BUF+1 );
+  buf  = (char *) SH_ALLOC( 2*SH_BUFSIZE+1 );
+  bufc = (char *) SH_ALLOC( 2*SH_BUFSIZE+1 );
 
   while (1 == 1) 
@@ -192,5 +190,5 @@
       /* get the log message
        */
-      if (sh_unix_getline (fd, buf, (2*SH_MSG_BUF)) < 0) 
+      if (sh_unix_getline (fd, buf, (2*SH_BUFSIZE)) < 0) 
 	break;
 
@@ -223,5 +221,5 @@
 	  start = 1;
 	  do {
-	    if ( sh_unix_getline (fd, buf, (2*SH_MSG_BUF)) < 0)
+	    if ( sh_unix_getline (fd, buf, (2*SH_BUFSIZE)) < 0)
 	      break;
 	  } while (buf[0] == '\0' || buf[0] == '\n');
@@ -294,5 +292,5 @@
 	{
 	  do {
-	    if ( sh_unix_getline (fd, bufc, (2*SH_MSG_BUF)) < 0)
+	    if ( sh_unix_getline (fd, bufc, (2*SH_BUFSIZE)) < 0)
 	      break;
 	  } while (bufc[0] == '\0' || bufc[0] == '\n');
@@ -302,7 +300,7 @@
 	      /* A continuation line. Add the newline. 
 	       */
-	      (void) sl_strlcat(buf, "\n", 2*SH_MSG_BUF+1);
+	      (void) sl_strlcat(buf, "\n", 2*SH_BUFSIZE+1);
 	      ++len;
-	      (void) sl_strlcat(buf, bufc, 2*SH_MSG_BUF+1);
+	      (void) sl_strlcat(buf, bufc, 2*SH_BUFSIZE+1);
 	      len += (int) sl_strlen(bufc);
 	    }
@@ -378,13 +376,12 @@
 	      key[0] = '\0';
 	      
-	      while (strlen(key) < KEY_LEN ) 
+	      while (sl_strlen(key) < KEY_LEN ) 
 		{ 
 		  if (key[0] != '\n' && key[0] != '\0')
-		    fprintf(stdout, "%s",_("New audit trail, enter key: "));
+		    fprintf(stdout, _("New audit trail, enter key: "));
 		  else if (key[0] == '\n')
 		    {
 		      (void) sl_strlcpy(key, 
-					sh_tiger_hash(NULL, TIGER_DATA, 0, 
-						      hashbuf, sizeof(hashbuf)), 
+					sh_tiger_hash(NULL, TIGER_DATA, 0), 
 					KEY_LEN+1);
 		      chk_mode = CHK_NON;
@@ -393,17 +390,15 @@
 		  (void) fflush(stdout); 
 		  key[0] = '\0';
-		  if (NULL != fgets(key, sizeof(key), stdin))
+		  (void) fgets(key, KEY_LEN+2, stdin);
+		  if (key[0] != '\n') 
 		    {
-		      if (key[0] != '\n') 
-			{
-			  if (key[strlen(key) - 1] == '\n')
-			    key[strlen(key) - 1] = '\0';
-			}
-		      if (key[0] == '/')
-			{
-			  chk_mode = CHK_FIL;
-			  (void) sl_strlcpy(path, key, KEY_LEN+1); 
-			  break;
-			}
+		      if (key[strlen(key) - 1] == '\n')
+			key[strlen(key) - 1] = '\0';
+		    }
+		  if (key[0] == '/')
+		    {
+		      chk_mode = CHK_FIL;
+		      (void) sl_strlcpy(path, key, KEY_LEN+1); 
+		      break;
 		    }
 		}
@@ -419,5 +414,5 @@
 		{
 		  chk_mode = CHK_KEY;
-		  fprintf(stdout, "%s",_("Key not found in file\n"));
+		  fprintf(stdout, _("Key not found in file\n"));
 		  goto findKey;
 		}
@@ -433,10 +428,9 @@
 	   */
 	  (void) sl_strlcpy (key, 
-			     sh_tiger_hash (key, TIGER_DATA, KEY_LEN,
-					    hashbuf, sizeof(hashbuf)), 
+			     sh_tiger_hash (key, TIGER_DATA, KEY_LEN), 
 			     KEY_LEN+1);
 	}
       
-      (void) sl_strlcat ( buf, key, 2*SH_MSG_BUF + 1);
+      (void) sl_strlcat ( buf, key, 2*SH_BUFSIZE + 1);
       
 #ifdef SH_STEALTH
@@ -446,6 +440,5 @@
       status = sl_strncmp (signature, 
 			   sh_tiger_hash (buf, TIGER_DATA, 
-					  (unsigned long) sl_strlen(buf),
-					  hashbuf, sizeof(hashbuf)),
+					  (unsigned long) sl_strlen(buf)),
 			   KEY_LEN);
       
@@ -541,5 +534,5 @@
   if (status == 0)
     {
-      fd = sl_open_write (FIL__, __LINE__, logfile, SL_YESPRIV);
+      fd = sl_open_write (logfile, SL_YESPRIV);
       if (SL_ISERROR(fd))
         {
@@ -560,7 +553,5 @@
         {
 	  tmp  = sh_util_safe_name (logfile);
-	  len      = sl_strlen(tmp);
-	  if (sl_ok_adds (6, len))
-	    len += 6;
+	  len      = 6 + sl_strlen(tmp);
 	  lockfile = SH_ALLOC(len);
 	  (void) sl_strlcpy(lockfile,        tmp, len);
@@ -598,6 +589,5 @@
         (*service_failure) = 1;
       }
-      if (tmp)
-	SH_FREE(tmp);
+      SH_FREE(tmp);
       SL_RETURN(-1, _("sh_log_open"));
     }
@@ -614,5 +604,5 @@
   char            sigkey_old[KEY_LEN+1];
   char            sigkey_new[KEY_LEN+1];
-  char            crypto[KEY_LEN+1];
+  char            crypt[KEY_LEN+1]; 
   struct  lfstc * next;
 } open_logfile;
@@ -623,5 +613,5 @@
 
 #ifdef SH_WITH_SERVER
-int set_flag_sep_log (const char * str)
+int set_flag_sep_log (char * str)
 {
   return sh_util_flagval(str, &flag_sep_log);
@@ -644,5 +634,5 @@
 
   SL_TICKET            fd = -1;
-  size_t               status;
+  long int             status;
   struct _sh_log_buf   log_msg;
 
@@ -652,6 +642,5 @@
   char               * sigkey_new;
   char               * sigkey_old;
-  char               * crypto;
-  char                 hashbuf[KEYBUF_SIZE];
+  char               * crypt;
 
   SL_ENTER(_("sh_log_file"));
@@ -667,5 +656,5 @@
 	  /* don't write second EOF mark
 	   */
-	  if (current->log_start != S_TRUE && sh.flag.islocked == GOOD)
+	  if (current->log_start != S_TRUE)
 	    {
 	      /* Don't use inet_peer == NULL, userwise a lock file will
@@ -743,7 +732,7 @@
       current->service_failure = 0;
       current->log_start       = S_TRUE;
-      memset(current->sigkey_old, 0, KEY_LEN+1);
-      memset(current->sigkey_new, 0, KEY_LEN+1);
-      memset(current->crypto,     0, KEY_LEN+1);
+      memset(current->sigkey_old, (int)'\0', KEY_LEN+1);
+      memset(current->sigkey_new, (int)'\0', KEY_LEN+1);
+      memset(current->crypt,      (int)'\0', KEY_LEN+1);
       current->next            = logfile_list;
       logfile_list             = current;
@@ -760,20 +749,14 @@
    */
 
-  status      =  sl_strlen (errmsg);
-  if (!sl_ok_adds(status, (2*KEY_LEN)) || !sl_ok_adds((2*KEY_LEN + status),32))
-    {
-      sl_close(fd);
-      SL_RETURN ((-1), _("sh_log_file"));
-    }
-      
+  status      = (long) sl_strlen (errmsg);
   log_msg.msg = (char *) SH_ALLOC ((size_t) (2*KEY_LEN + status + 32)); 
 
 #if defined(HAVE_MLOCK) && !defined(HAVE_BROKEN_MLOCK)
-  if (skey->mlock_failed == S_FALSE) 
-    {
-      if ( (-1) == sh_unix_mlock( FIL__, __LINE__, log_msg.msg, 
+  if (skey->mlock_failed == SL_FALSE) 
+    {
+      if ( (-1) == sh_unix_mlock( log_msg.msg, 
 				  (size_t)(2*KEY_LEN + status + 32) ) ) 
 	{
-	  skey->mlock_failed = S_TRUE;
+	  skey->mlock_failed = SL_TRUE;
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
 	  sh_error_handle ((-1), FIL__, __LINE__, EPERM, MSG_MLOCK); 
@@ -782,7 +765,7 @@
     }
 #else
-  if (skey->mlock_failed == S_FALSE) 
-    {
-      skey->mlock_failed = S_TRUE;
+  if (skey->mlock_failed == SL_FALSE) 
+    {
+      skey->mlock_failed = SL_TRUE;
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE)
       sh_error_handle ((-1), FIL__, __LINE__, EPERM, MSG_MLOCK);
@@ -858,5 +841,5 @@
       sigkey_old = current->sigkey_old;
       sigkey_new = current->sigkey_new;
-      crypto     = current->crypto;
+      crypt      = current->crypt;
     }
   else
@@ -864,5 +847,5 @@
       sigkey_old = skey->sigkey_old;
       sigkey_new = skey->sigkey_new;
-      crypto     = skey->crypt;      /* flawfinder: ignore */
+      crypt      = skey->crypt;
     }
 
@@ -881,20 +864,19 @@
        */
       (void) sl_strlcpy(sigkey_new, 
-			sh_tiger_hash (sigkey_old, TIGER_DATA, KEY_LEN,
-				       hashbuf, sizeof(hashbuf)), 
+			sh_tiger_hash (sigkey_old, TIGER_DATA, KEY_LEN), 
 			KEY_LEN+1);
 
       /* Copy it to 'crypt' for encryption.
        */
-      (void) sl_strlcpy(crypto, sigkey_new, KEY_LEN+1);
+      (void) sl_strlcpy(crypt, sigkey_new, KEY_LEN+1);
 
       /* Use message and compiled-in key to encrypt.
        */
       BREAKEXIT(sh_util_encode);
-      sh_util_encode(crypto, log_msg.msg, 0, 'B');
+      sh_util_encode(crypt, log_msg.msg, 0, 'B');
 
       /* Send out the key.
        */
-      (void) sh_unix_time(0, log_msg.timestamp, KEY_LEN+1); 
+      (void) sl_strlcpy(log_msg.timestamp, sh_unix_time(0), KEY_LEN+1); 
 
       store1               = errFlags.loglevel;
@@ -918,6 +900,6 @@
 
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_START_KEY_MAIL,
-		       sh.prg_name, crypto, 
-		       crypto, log_msg.timestamp);
+		       sh.prg_name, crypt, 
+		       crypt, log_msg.timestamp);
 
       /* send to other allowed channels
@@ -931,5 +913,5 @@
 
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_START_KEY,
-		       sh.prg_name, crypto);
+		       sh.prg_name, crypt);
 
       /* Cleanup.
@@ -944,5 +926,5 @@
 
 
-      memset (crypto, 0, KEY_LEN);
+      memset (crypt, (int) '\0', KEY_LEN);
       sh.flag.log_start    = S_FALSE;  
       current->log_start   = S_FALSE;
@@ -952,6 +934,5 @@
       log_msg.timestamp[0] = '\0';
       (void) sl_strlcpy (sigkey_new, 
-			 sh_tiger_hash (sigkey_old, TIGER_DATA, KEY_LEN, 
-					hashbuf, sizeof(hashbuf)),
+			 sh_tiger_hash (sigkey_old, TIGER_DATA, KEY_LEN),
 			 KEY_LEN+1);
     }
@@ -959,35 +940,32 @@
   /* --- Sign the message with the signature key. ---
    */
-  sh_tiger_hash (log_msg.msg, TIGER_DATA,
-		 (unsigned long)(status + KEY_LEN), 
-		 (char *) hashbuf, (size_t) sizeof(hashbuf));
 
   (void) sl_strlcat (log_msg.msg, sigkey_new, (size_t)(status + KEY_LEN + 2));
+  
   (void) sl_strlcpy (log_msg.signature,
-		     sh_tiger_hash (log_msg.msg, (TigerType) TIGER_DATA,
-				    (unsigned long)(status + KEY_LEN), 
-				    hashbuf, sizeof(hashbuf)),
+		     sh_tiger_hash (log_msg.msg, TIGER_DATA, 
+				    (unsigned long)(status + KEY_LEN)), 
 		     KEY_LEN+1);
   (void) sl_strlcpy (sigkey_old, sigkey_new, KEY_LEN+1); 
 
-  /*@-usedef@*/
+  /*@-bufferoverflowhigh -usedef@*/
 #ifdef SH_USE_XML
   if (log_msg.timestamp[0] != '\0')
-    sl_snprintf(log_msg.sig, sizeof(log_msg.sig),
+    sprintf(log_msg.sig,                            /* known to fit  */
 #ifdef FIX_XML
-		_("\n<sig>%s%s</sig></log>\n"),          /* <sig> FIX XML */
-#else
-		_("\nsig>%s%s</sig></log>\n"),          /* <sig> FIX XML */
-#endif
-		log_msg.signature, log_msg.timestamp);
+	    _("\n<sig>%s%s</sig></log>\n"),          /* <sig> FIX XML */
+#else
+	    _("\nsig>%s%s</sig></log>\n"),          /* <sig> FIX XML */
+#endif
+	    log_msg.signature, log_msg.timestamp);
   else
-    sl_snprintf(log_msg.sig, sizeof(log_msg.sig),
+    sprintf(log_msg.sig,                            /* known to fit  */
 #ifdef FIX_XML
-		_("\n<sig>%s</sig></log>\n"),            /* <sig> FIX XML */
-#else
-		_("\nsig>%s</sig></log>\n"),            /* <sig> FIX XML */
-#endif
-		log_msg.signature);
-  /*@+usedef@*/
+	    _("\n<sig>%s</sig></log>\n"),            /* <sig> FIX XML */
+#else
+	    _("\nsig>%s</sig></log>\n"),            /* <sig> FIX XML */
+#endif
+	    log_msg.signature);
+  /*@+bufferoverflowhigh +usedef@*/
 
 #ifdef SH_STEALTH
@@ -1046,6 +1024,6 @@
   /* --- Clean up and free record. ---
    */
-  memset (log_msg.msg,       0, (size_t)(status + 2*KEY_LEN + 32));
-  memset (log_msg.signature, 0, KEY_LEN);
+  memset (log_msg.msg,       (int)'\0', (size_t)(status + 2*KEY_LEN + 32));
+  memset (log_msg.signature, (int)'\0', KEY_LEN);
   (void) sh_unix_munlock (log_msg.msg,  
 			  (size_t)(status + 2*KEY_LEN + 32));
@@ -1055,278 +1033,2 @@
 }
 
-/* >>>>>>>>>>>>>>>>>>>>>>>>>>>> efile <<<<<<<<<<<<<<<<<< */
-
-static char * gEfile = NULL;
-static int    gFail  = 0;
-static long   gGid   = 0;
-
-int sh_efile_group(const char * str)
-{
-  int  fail;
-  long gid = sh_group_to_gid(str, &fail);
-
-  if (fail < 0)
-    {
-      return -1;
-    }
-  gGid = gid;
-  return 0;
-}
-
-
-int sh_efile_path(const char * str) 
-{
-  if (!str || !strcmp(str, _("none")))
-    {
-      if (gEfile)
-	SH_FREE(gEfile);
-      gEfile = NULL;
-    }
-  else if (str[0] != '/')
-    {
-      return -1;
-    }
-  else
-    {
-      if (gEfile)
-	SH_FREE(gEfile);
-      gEfile = sh_util_strdup(str);
-    }
-  gFail = 0;
-  return 0;
-}
-
-/* write lock for filename
- */
-static int sh_efile_lock (char * filename, int flag)
-{
-  extern int get_the_fd (SL_TICKET ticket);
-  size_t len;
-  int    res = -1;
-  char myPid[64];
-  SL_TICKET  fd;
-  char * lockfile;
-  int    status;
-
-  sprintf (myPid, "%ld\n", (long) sh.pid);             /* known to fit  */
-
-  if (filename == NULL)
-    return res;
-
-  len = sl_strlen(filename);
-  if (sl_ok_adds(len, 6))
-    len += 6;
-  lockfile = SH_ALLOC(len);
-  sl_strlcpy(lockfile, filename,   len);
-  sl_strlcat(lockfile, _(".lock"), len);
-
-  if (  0 !=  (status = tf_trust_check (lockfile, SL_YESPRIV))
-	&& gFail == 0)
-    {
-      char * tmp  = sh_util_safe_name (lockfile);
-      sh_error_handle ((-1), FIL__, __LINE__, status, MSG_E_TRUST,
-			   (long) sh.effective.uid, tmp);
-      ++gFail;
-      SH_FREE(tmp);
-    }
-
-  if (status == 0)
-    {
-      if (flag == 0)
-	{
-	  /* --- Delete the lock file. --- 
-	   */
-	  res = retry_aud_unlink (FIL__, __LINE__, lockfile);
-	}
-      else
-	{
-	  unsigned int count = 0;
-
-	  /* fails if file exists 
-	   */
-	  do {
-	    fd = sl_open_safe_rdwr (FIL__, __LINE__, 
-				    lockfile, SL_YESPRIV);
-	    if (SL_ISERROR(fd))
-	      {
-		retry_msleep(0, 100);
-		++count;
-	      }
-
-	  } while (SL_ISERROR(fd) && count < 3);
-      
-	  if (!SL_ISERROR(fd))
-	    {
-	      int filed;
-
-	      res = sl_write (fd, myPid, sl_strlen(myPid));
-	      filed = get_the_fd(fd);
-	      fchmod (filed, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
-	      sl_close (fd);
-	    }
-	  else
-	    {
-	      static int nFail = 0;
-
-	      if (nFail == 0)
-		{
-		  char errmsg[1024];
-		  char * tmp  = sh_util_safe_name (lockfile);
-		  
-		  sl_snprintf(errmsg, sizeof(errmsg), 
-			      _("Error creating lockfile %s"),
-			      tmp);
-		  
-		  sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, 
-				   0, MSG_E_SUBGEN,
-				   errmsg, _("sh_efile_lock"));
-		  ++nFail;
-		  SH_FREE(tmp);
-		}
-	    }
-	}
-    }
-
-  SH_FREE(lockfile);
-  return res;
-}
-
-static size_t gSave[6] = { 0 };
-
-static void sh_efile_clear()
-{
-  int i;
-
-  for (i = 0; i < 6; ++i)
-    gSave[i] = 0;
-  return;
-}
-
-static void sh_efile_load(size_t * tmp)
-{
-  int i;
-
-  if (S_TRUE == sl_ok_adds (gSave[0], sh.statistics.bytes_hashed))
-    gSave[0] += sh.statistics.bytes_hashed;
-  if (S_TRUE == sl_ok_adds (gSave[1], sh.statistics.dirs_checked))
-    gSave[1] += sh.statistics.dirs_checked;
-  if (S_TRUE == sl_ok_adds (gSave[2], sh.statistics.files_checked))
-    gSave[2] += sh.statistics.files_checked;
-  if (S_TRUE == sl_ok_adds (gSave[3], sh.statistics.files_report))
-    gSave[3] += sh.statistics.files_report;
-  if (S_TRUE == sl_ok_adds (gSave[4], sh.statistics.files_error))
-    gSave[4] += sh.statistics.files_error;
-  if (S_TRUE == sl_ok_adds (gSave[5], sh.statistics.files_nodir))
-    gSave[5] += sh.statistics.files_nodir;
-
-  for (i = 0; i < 6; ++i)
-    tmp[i] = gSave[i];
-  return;
-}
-
-void sh_efile_report()
-{
-  extern int get_the_fd (SL_TICKET ticket);
-  SL_TICKET     fd;
-  char         *efile;
-  int           status = -1;
-
-  if (gEfile)
-    {
-      size_t tmp[6];
-
-      sh_efile_load(tmp);
-
-      efile = sh_util_strdup(gEfile);
-      
-      if (sh_efile_lock (efile, 1) < 0)
-	goto end;
-
-      if (  0 !=  (status = tf_trust_check (efile, SL_YESPRIV))
-	    && gFail == 0)
-	{
-	  char * tmp  = sh_util_safe_name (efile);
-	  sh_error_handle ((-1), FIL__, __LINE__, status, MSG_E_TRUST,
-			   (long) sh.effective.uid, tmp);
-	  ++gFail;
-	  SH_FREE(tmp);
-	}
-      
-      if (status == 0)
-	{
-	  fd = sl_open_write (FIL__, __LINE__, efile, SL_YESPRIV);
-
-	  if (!SL_ISERROR(fd))
-	    {
-	      char report[511];
-	      char tstamp[TIM_MAX];
-
-	      time_t now = time(NULL);
-	      int  filed = get_the_fd(fd);
-
-	      (void) sh_unix_time (now, tstamp, sizeof(tstamp));
-#ifdef HAVE_LONG_LONG
-	      sl_snprintf(report, sizeof(report), 
-			  _("%s %lld %ld %ld %ld %ld %ld %ld\n"),
-			  tstamp,
-			  (long long) now,
-			  (long) tmp[0], (long) tmp[1], (long) tmp[2], 
-			  (long) tmp[3], (long) tmp[4], (long) tmp[5]);
-#else
-	      sl_snprintf(report, sizeof(report), 
-			  _("%s %ld %ld %ld %ld %ld %ld %ld\n"),
-			  tstamp,
-			  (long) now,
-			  (long) tmp[0], (long) tmp[1], (long) tmp[2], 
-			  (long) tmp[3], (long) tmp[4], (long) tmp[5]);
-#endif
-			  
-	      status = sl_forward(fd);
-	      if (!SL_ISERROR(status))
-		sl_write (fd, report,  strlen(report));
-	      (void) sl_sync(fd);
-
-	      /* make group writeable, such that nagios can truncate */
-	      fchmod (filed, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
-	      status = fchown (filed, -1, gGid);
-	      if (status < 0)
-		{
-		  int  errnum = errno;
-		  static int nFail = 0;
-		  if (nFail == 0)
-		    {
-		      char errmsg[1024];
-		      char buf[256];
-		      char * tmp  = sh_util_safe_name (efile);
-
-		      sl_snprintf(errmsg, sizeof(errmsg), 
-				  _("Error changing group of %s to %ld: %s"),
-				  tmp, gGid, 
-				  sh_error_message (errnum, buf, sizeof(buf)));
-		      sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, 
-				       errnum, MSG_E_SUBGEN,
-				       errmsg, _("sh_efile_report"));
-		      ++nFail;
-		      SH_FREE(tmp);
-		    }
-		}
-
-	      (void) sl_close(fd);
-	    }
-	  else
-	    {
-	      status = -1;
-	    }
-	}
-  
-      (void) sh_efile_lock (efile, 0);
-    end:
-      SH_FREE(efile);
-
-      if (!SL_ISERROR(status))
-	{
-	  sh_efile_clear();
-	}
-    }
-  return;
-}
Index: /trunk/src/sh_err_syslog.c
===================================================================
--- /trunk/src/sh_err_syslog.c	(revision 584)
+++ /trunk/src/sh_err_syslog.c	(revision 1)
@@ -31,5 +31,5 @@
 
 typedef struct log_fac_struct {
-  const char * name;
+  char * name;
   int    facility;
 } logfct;
@@ -110,5 +110,5 @@
 /* set syslog facility 
  */
-int  sh_log_set_facility (const char * c)
+int  sh_log_set_facility (char * c)
 {
   int loop = 0; 
@@ -131,26 +131,5 @@
 }
   
-static int sh_stamp_priority = LOG_ERR;
-
-/* set priority for heartbeat messages
- */
-int  sh_log_set_stamp_priority (const char * c)
-{
-  int retval = 0;
-
-  if      (0 == strcmp(c, _("LOG_DEBUG")))   { sh_stamp_priority = LOG_DEBUG; }
-  else if (0 == strcmp(c, _("LOG_INFO")))    { sh_stamp_priority = LOG_INFO;  }
-  else if (0 == strcmp(c, _("LOG_NOTICE")))  { sh_stamp_priority = LOG_NOTICE;}
-  else if (0 == strcmp(c, _("LOG_WARNING"))) { sh_stamp_priority = LOG_WARNING;}
-  else if (0 == strcmp(c, _("LOG_ERR")))     { sh_stamp_priority = LOG_ERR;   }
-  else if (0 == strcmp(c, _("LOG_CRIT")))    { sh_stamp_priority = LOG_CRIT;  }
-  else if (0 == strcmp(c, _("LOG_ALERT")))   { sh_stamp_priority = LOG_ALERT; }
-#ifdef LOG_EMERG
-  else if (0 == strcmp(c, _("LOG_EMERG")))   { sh_stamp_priority = LOG_EMERG; }
-#endif
-  else { retval = -1; }
-
-  return retval;
-}  
+  
 
 /* syslog error message
@@ -175,5 +154,5 @@
   else if (severity == SH_ERR_NOTICE) priority = LOG_NOTICE;
   else if (severity == SH_ERR_WARN)   priority = LOG_WARNING;
-  else if (severity == SH_ERR_STAMP)  priority = sh_stamp_priority;
+  else if (severity == SH_ERR_STAMP)  priority = LOG_ERR;
   else if (severity == SH_ERR_ERR)    priority = LOG_ERR;
   else if (severity == SH_ERR_SEVERE) priority = LOG_CRIT;
